USE hesistemas02;

DROP TABLE IF EXISTS pacotes;
CREATE TABLE pacotes (
    id INT(10) NOT NULL AUTO_INCREMENT,
    pacote VARCHAR(100),
    caminho TEXT,
    total INT(10) COMMENT "Total de strings do pacote",
    pendentes INT(10) COMMENT "Strings nao traduzidas",
    restante DECIMAL(16, 2) COMMENT "Percentual restante para concluir o pacote",
    upstream TINYINT(1) DEFAULT 0,
    CONSTRAINT pk_pacotes PRIMARY KEY (id)
) engine = InnoDB;

DROP PROCEDURE IF EXISTS up_SalvarPacote;
DELIMITER //
CREATE PROCEDURE up_SalvarPacote(IN pacote VARCHAR(100), IN url TEXT, IN total INT(10), IN pendentes INT(10))
BEGIN
    SET @pacote = pacote;
    SET @url = url;
    SET @total = total;
    SET @pendentes = pendentes;
    SET @restante = ((@pendentes * 100) / @total);

    SET @codigo = (SELECT COUNT(id) FROM pacotes WHERE pacotes.pacote = @pacote AND pacotes.caminho = @url);

    IF (@codigo > 0) THEN
        SET @codigo = (SELECT id FROM pacotes WHERE pacotes.pacote = @pacote AND pacotes.caminho = @url);

        IF (@pendentes > 0) THEN
            UPDATE pacotes SET
                pacotes.pacote = @pacote,
                pacotes.total = @total,
                pacotes.pendentes = @pendentes,
                pacotes.restante = @restante,
                pacotes.caminho = @url
            WHERE pacotes.id = @codigo;
        ELSE
            DELETE FROM pacotes WHERE pacotes.id = @codigo;
        END IF;
    ELSE
        INSERT INTO pacotes VALUES (null, @pacote, @url, @total, @pendentes, @restante, 0);
    END IF;
END; //
DELIMITER ;
